/* EV_Controller.c */

#include "C.h"
#include "EV_Controller.h"

/*==================================================================
  ֐
==================================================================*/
void EV_Controller(struct EV_Controller *This, Thread *th)
{
	/*  */
	This->p_P = &This->P;
	Position(This->p_P);
	UpMotor(&This->UPMT);
	DownMotor(&This->DNMT);
	WaitPositionChangeLog(&This->WPCL);
	This->p_DR = &This->DR;
	Door(This->p_DR);
	OpenMotor(&This->OPMT);
	CloseMotor(&This->CLMT);
	WaitDoorChangeLog(&This->WDCL);
	EV_Time(&This->T, th);
	EV_File(&This->SF);
	EV_File(&This->LF);
	EV_File(&This->CF);
	EV_File(&This->PCF);
	EV_File(&This->PTOF);
	EV_File(&This->MF);
	
	/* S */
	This->p_Safety = &This->Safety;
	/* Limit */
	This->p_str = &This->str[0];
	/* ߏ */
	This->p_Command = &This->Command;
	This->p_PermitCommand = &This->PermitCommand;
	This->p_PermitTurnOpen = &This->PermitTurnOpen;
	
	/* [^[~ */
	Motor_Write(&This->MF, 's');
	
	/* Gx[^[̈ʒuzO */
	/* l */
	OnInitWaitPositionChangeLog(&This->WPCL, This->p_P);

	/* Gx[^[̈ʒuzO */
	/* l */
	OnInitWaitDoorChangeLog(&This->WDCL, This->p_DR);

	/* ~bgXCb`̑Oԓǂݍ */
	ReadString(&This->LF, "Limit.txt\0", This->p_str, 9);
	/* ߏ */
	if(Command_Write(&This->CF, 'N') == NG) return;
	if(PermitCommand_Write(&This->PCF, 'c') == NG) return;
	if(PermitTurnOpen_Write(&This->PTOF, 'N') == NG) return;
}

/*
 * 吧֐
 */
void OnController(struct EV_Controller *This, Thread *th)
{
	/* S */
	if(Read(&This->SF, "Safety.txt\0", This->p_Safety) == NG) return;
	/* ~bgXCb`̑Oԓǂݍ */
	ReadString(&This->LF, "Limit.txt\0", This->p_str, 9);
	/* ߓ */
	if(Command_Read(&This->CF, This->p_Command) == NG) return;
	/* ͋ */
	if(PermitCommand_Read(&This->PCF, This->p_PermitCommand) == NG) return;
	/* ]J */
	if(PermitTurnOpen_Read(&This->PTOF, This->p_PermitTurnOpen) == NG) return;
	
	switch(This->Command){
	/* I߂Ȃ */
	case 'q':
		Motor_Write(&This->MF, 's');
		delete_(th);
		break;
	/* ~߂Ȃ */
	case 's':
		SetPermit(&This->T, OFF);
		break;
	/* A߂Ȃ */
	case 'r':
		break;
	/* KĖ߂Ȃ */
	case 'Y':
		if((*This->p_P->p_UnderStop == ON) && (*This->p_DR->p_CloserStop == OFF)){
			break;
		}
	/* ㏸߂Ȃ */
	case 'u':
		if(*This->p_P->p_UpperStop == ON){
			/* J */
			if(*This->p_DR->p_OpennerStop == ON){
				PermitCommand_Write(&This->PCF, 'c');
				SetPermit(&This->T, ON);
				Command_Write(&This->CF, 'N');
				Clear();
				PrintF(Panel, "Hello EV        ");
				break;
			}
			else{
				SetPermit(&This->T, OFF);
				SetCurrentTime(&This->T);
				/* J */
				Open(This->p_DR,This->OPMT,This->WDCL, This->p_Safety);
			}
		}
		else if(*This->p_DR->p_CloserStop == ON){
			/*  */
			SetPermit(&This->T, OFF);
			SetCurrentTime(&This->T);
			PermitTurnOpen_Write(&This->PTOF, 'N');
			/* ㏸ */
			Up(This->p_P,This->UPMT,This->WPCL, This->p_Safety);
		}
		else if(*This->p_DR->p_CloserStop == OFF){
			SetPermit(&This->T, OFF);
			SetCurrentTime(&This->T);
			/*  */
			Close(This->p_DR,This->CLMT,This->WDCL, This->p_Safety);
		}
		else{
			SetPermit(&This->T, OFF);
			SetCurrentTime(&This->T);
		}
		break;
	/* KĖ߂Ȃ */
	case 'y':
		if((*This->p_P->p_UpperStop == ON) && (*This->p_DR->p_CloserStop == OFF)){
			break;
		}
	/* ~߂Ȃ */
	case 'd':
		if(*This->p_P->p_UnderStop == ON){
			/* J */
			if(*This->p_DR->p_OpennerStop == ON){
				PermitCommand_Write(&This->PCF, 'c');
				SetPermit(&This->T, ON);
				Command_Write(&This->CF, 'N');
				Clear();
				PrintF(Panel, "Hello EV        ");
				break;
			}
			else{
				SetPermit(&This->T, OFF);
				SetCurrentTime(&This->T);
				/* J */
				Open(This->p_DR,This->OPMT,This->WDCL, This->p_Safety);
			}
		}
		else if(*This->p_DR->p_CloserStop == ON){
			/*  */
			SetPermit(&This->T, OFF);
			SetCurrentTime(&This->T);
			PermitTurnOpen_Write(&This->PTOF, 'N');
			/* ~ */
			Down(This->p_P,This->DNMT,This->WPCL, This->p_Safety);
		}
		else if(*This->p_DR->p_CloserStop == OFF){
			SetPermit(&This->T, OFF);
			SetCurrentTime(&This->T);
			/*  */
			Close(This->p_DR,This->CLMT,This->WDCL, This->p_Safety);
		}
		else{
			SetPermit(&This->T, OFF);
			SetCurrentTime(&This->T);
		}
		break;
	/* J߂Ȃ */
	case 'o':
		/* J */
		if(*This->p_DR->p_OpennerStop == ON){
			PermitCommand_Write(&This->PCF, 'c');
			SetPermit(&This->T, ON);
			Command_Write(&This->CF, 'N');
			Clear();
			PrintF(Panel, "Hello EV        ");
			break;
		}
		else{
			SetPermit(&This->T, OFF);
			SetCurrentTime(&This->T);
			/* J */
			Open(This->p_DR,This->OPMT,This->WDCL, This->p_Safety);
		}
		break;
	/* ߂Ȃ */
	case 'c':
		SetPermit(&This->T, OFF);
		SetCurrentTime(&This->T);
		/*  */
		if(*This->p_DR->p_CloserStop == ON){
			PermitTurnOpen_Write(&This->PTOF, 'N');
			Command_Write(&This->CF, 'N');
			PermitCommand_Write(&This->PCF, 'c');
			Clear();
			PrintF(Panel, "Hello EV        ");
			break;
		}
		else{
			/*  */
			Close(This->p_DR,This->CLMT,This->WDCL, This->p_Safety);
		}
		break;
	/* ߂Ȃ */
	case 'H':
		if(*This->p_P->p_UpperStop == ON){
			SetPermit(&This->T, OFF);
			SetCurrentTime(&This->T);
			/*  */
			if(*This->p_DR->p_CloserStop == ON){
				Command_Write(&This->CF, 'N');
				PermitTurnOpen_Write(&This->PTOF, 'N');
				PermitCommand_Write(&This->PCF, 'c');
				Clear();
				PrintF(Panel, "Hello EV        ");
				break;
			}
			else{
				/*  */
				Close(This->p_DR,This->CLMT,This->WDCL, This->p_Safety);
			}
		}
		
		break;
	/* ߂Ȃ */
	case 'h':
		if(*This->p_P->p_UnderStop == ON){
			SetPermit(&This->T, OFF);
			SetCurrentTime(&This->T);
			/*  */
			if(*This->p_DR->p_CloserStop == ON){
				Command_Write(&This->CF, 'N');
				PermitTurnOpen_Write(&This->PTOF, 'N');
				PermitCommand_Write(&This->PCF, 'c');
				Clear();
				PrintF(Panel, "Hello EV        ");
				break;
			}
			else{
				/*  */
				Close(This->p_DR,This->CLMT,This->WDCL, This->p_Safety);
			}
		}
		break;
	default:
		break;
	}
	if((GetCurrentTime(&This->T) >= OPENTIMEOUT) && (*This->p_DR->p_OpennerStop == ON) && (GetPermit(&This->T) == ON)){
		SetPermit(&This->T, OFF);
		SetCurrentTime(&This->T);
		PermitTurnOpen_Write(&This->PTOF, 'o');
		PermitCommand_Write(&This->PCF, 'N');
		/*  */
		Command_Write(&This->CF, 'c');
	}
	return;
}
