/* EV_File.c */

#include "C.h"
#include "EV_File.h"

/*==================================================================
  t@CsgpIuWFNg錾
==================================================================*/
#ifdef NOTUSE_FILES
Handle_EV_Status status;
#endif

/*==================================================================
  t@C\֐
==================================================================*/
#ifdef NOTUSE_FILES
void new_EV_Status(EV_Status *This)
{
	This->p_status = &status;
	status.safety = 'r';
	status.p_limit = &status.limit[0];
	strcpy(status.p_limit, "yynnyynn\0");
	status.motor = 's';
	status.command = 'N';
	status.permitcommand = 'N';
	status.permitturnopen = 'N';
}
#endif

void EV_File(struct EV_File *This)
{
	/* l */
	This->fp = NULL;
	
	/* ߂ */
	return;
}

#ifdef NOTUSE_FILES
int Write(struct EV_File *This, char *filename, char ch)
{
	switch(filename[0])
	{
	case 'S':
		status.safety = ch;
		break;
	case 'M':
		status.motor = ch;
		break;
	case 'C':
		status.command = ch;
		break;
	case 'P':
		switch(filename[6])
		{
		case 'C':
			status.permitcommand = ch;
			break;
		case 'T':
			status.permitturnopen = ch;
			break;
		default:
			break;
		}
		break;
	default:
		break;
	}
	return OK;
}
#else
int Write(struct EV_File *This, char *filename, char ch)
{
	int Ret = OK;
	if((This->fp = fopen(filename, "w")) == NULL){
		Ret = NG;
	}
	else if(fputc((int) ch, This->fp) == ch){
		fclose(This->fp);
		Ret = OK;
	}
	else{
		fclose(This->fp);
		Ret = NG;
	}
	return Ret;
}
#endif

#ifdef NOTUSE_FILES
int WriteString(struct EV_File *This, char *filename, char *str)
{
	switch(filename[0])
	{
	case 'L':
		status.p_limit = &status.limit[0];
		strcpy(status.p_limit, str);
		break;
	default:
		break;
	}
	return OK;
}
#else
/* 񏑂 */
int WriteString(struct EV_File *This, char *filename, char *str)
{
	int Ret = OK;
	if((This->fp = fopen(filename, "w")) == NULL){
		Ret = NG;
	}
	/* \n͒ǋLȂ */
	else if(fputs(str, This->fp) >= 0){
		fclose(This->fp);
		/* ݐ */
		Ret = OK;
	}
	else{
		fclose(This->fp);
		/* ݎs */
		Ret = NG;
	}
	return Ret;
}
#endif

#ifdef NOTUSE_FILES
int Read(struct EV_File *This, char *filename, char *p_ch)
{
	switch(filename[0])
	{
	case 'S':
		*p_ch = status.safety;
		break;
	case 'M':
		*p_ch = status.motor;
		break;
	case 'C':
		*p_ch = status.command;
		break;
	case 'P':
		switch(filename[6])
		{
		case 'C':
			*p_ch = status.permitcommand;
			break;
		case 'T':
			*p_ch = status.permitturnopen;
			break;
		default:
			break;
		}
		break;
	default:
		break;
	}
	return OK;
}
#else
int Read(struct EV_File *This, char *filename, char *p_ch)
{
	int Ret = OK;
	if((This->fp = fopen(filename, "r")) == NULL){
		Ret = NG;
	}
	else if((*p_ch = fgetc(This->fp)) == EOF){
		fclose(This->fp);
		Ret = ONE_MORE_TIME;
	}
	else if(*p_ch == '\n'){
		fclose(This->fp);
		Ret = ONE_MORE_TIME;
	}
	else if(*p_ch == 'N'){
		fclose(This->fp);
		Ret = ONE_MORE_TIME;
	}
	else{
		fclose(This->fp);
		Ret = OK;
	}
	return Ret;
}
#endif

#ifdef NOTUSE_FILES
int ReadString(struct EV_File *This, char *filename, char *str, int strlength)
{
	switch(filename[0])
	{
	case 'L':
		status.p_limit = &status.limit[0];
		strcpy(str, status.p_limit);
		break;
	default:
		break;
	}
	return OK;
}
#else
int ReadString(struct EV_File *This, char *filename, char *str, int strlength)
{
	int Ret = OK;
	if((This->fp = fopen(filename, "r")) == NULL){
		Ret = NG;
	}
	else if(fgets(str, strlength, This->fp) == NULL){
		fclose(This->fp);
		Ret = ONE_MORE_TIME;
	}
	else if(str[0] == '\n'){
		fclose(This->fp);
		Ret = ONE_MORE_TIME;
	}
	else if(str[0] == 'N'){
		fclose(This->fp);
		Ret = ONE_MORE_TIME;
	}
	else{
		fclose(This->fp);
		Ret = OK;
	}
	return Ret;
}
#endif

int PermitCommand_Read(struct EV_File *This, char *p_PermitCommand)
{
	int Ret = OK;
	switch(Read(This, "PermitCommand.txt\0", p_PermitCommand)){
	case NG:
		PrintF(ClsPnl, "\nReading Error");
		Ret = NG;
		break;
	case ONE_MORE_TIME:
		Ret = ONE_MORE_TIME;
		break;
	default:
		Ret = OK;
		break;
	}
	return Ret;
}

int PermitCommand_Write(struct EV_File *This, char PermitCommand)
{
	int Ret = OK;
	switch(Write(This, "PermitCommand.txt\0", PermitCommand)){
	case NG:
		PrintF(ClsPnl, "\nWriting Error");
		Ret = NG;
		break;
	case OK:
		Ret = OK;
		break;
	default:
		Ret = NG;
		break;
	}
	return Ret;
}

int Command_Read(struct EV_File *This, char *p_Command)
{
	int Ret = OK;
	switch(Read(This, "Command.txt\0", p_Command)){
	case NG:
		PrintF(ClsPnl, "\nReading Error");
		Ret = NG;
		break;
	case ONE_MORE_TIME:
		Ret = ONE_MORE_TIME;
		break;
	default:
		Ret = OK;
		break;
	}
	return Ret;
}

int Command_Write(struct EV_File *This, char Command)
{
	int Ret = OK;
	switch(Write(This, "Command.txt\0", Command)){
	case NG:
		PrintF(ClsPnl, "\nWriting Error");
		Ret = NG;
		break;
	case OK:
		Ret = OK;
		break;
	default:
		Ret = NG;
		break;
	}
	return Ret;
}

int PermitTurnOpen_Read(struct EV_File *This, char *p_PermitTurnOpen)
{
	int Ret = OK;
	switch(Read(This, "PermitTurnOpen.txt\0", p_PermitTurnOpen)){
	case NG:
		PrintF(ClsPnl, "\nReading Error");
		Ret = NG;
		break;
	case ONE_MORE_TIME:
		Ret = ONE_MORE_TIME;
		break;
	default:
		Ret = OK;
		break;
	}
	return Ret;
}

int PermitTurnOpen_Write(struct EV_File *This, char PermitTurnOpen)
{
	int Ret = OK;
	switch(Write(This, "PermitTurnOpen.txt\0", PermitTurnOpen)){
	case NG:
		PrintF(ClsPnl, "\nWriting Error");
		Ret = NG;
		break;
	case OK:
		Ret = OK;
		break;
	default:
		Ret = NG;
		break;
	}
	return Ret;
}

void Motor_Write(struct EV_File *This, char Motor)
{
	switch(Write(This, "Motor.txt\0", Motor)){
	case NG:
		PrintF(ClsPnl, "\nWriting Error");
		break;
	case OK:
		return;
		break;
	default:
		break;
	}
	
	/* ߂ */
	return;
}

char Motor_Read(struct EV_File *This)
{
	char ch;
	char *p_ch;
	ch = '\0';
	p_ch = &ch;

	switch(Read(This, "Motor.txt\0", p_ch)){
	case NG:
		break;
	case ONE_MORE_TIME:
		return '\0';
		break;
	case OK:
		return ch;
		break;
	default:
		break;
	}
	return '\0';
}

void Limit_Read(struct EV_File *This, char *str)
{
	switch(ReadString(This, "Limit.txt\0", str, 9)){
	case NG:
		PrintF(ClsPnl, "\nReading Error");
		break;
	case ONE_MORE_TIME:
		return;
		break;
	default:
		return;
		break;
	}
	
	/* ߂ */
	return;
}
