/* EV_Log.c */

#include "C.h"
#include "EV_Log.h"

#define DBSERVER "localhost"
#define DBID "pi"
#define DBPASSWORD "raspberry"
#define DBNAME "ev001"
#define DBPORTNO 3306

#define SERVER_NAME "127.0.0.1"
#define ERR -1
#define BUFSIZE 1024

#ifdef USE_CENTOS
/* M[U[(Linux Login ID) */
#define MAIL_FROM_HOST "work"
/* MT[o[(g IP 127.0.0.1) */
#define MAIL_FROM_SERVER "localhost.localdomain"
/* M */
#define MAIL_FROM_HOST_AT_SERVER "work@localhost.localdomain"
/* M(M E-mail address) */
#define RCPT_TO_HOST_AT_SERVER "work@localhost.localdomain"
#endif
/* M[et@C */
#define SEND_DATA "./EV_Mail.txt"

char *command_name;
int socket(int domain, int type, int protocol);
/* ~bZ[W̃[ʕ̃vg^Cv */
void emergency(void);

/* databaseڑ */
void EV_Log(struct EV_Log *This)
{
	This->conn = NULL;
	This->resp = NULL;
	This->p_ch_safety = &This->ch_safety;
	This->p_str_limit = &This->str_limit[0];
	This->p_ch_command = &This->ch_command;
	This->p_ch_permitcommand = &This->ch_permitcommand;
	This->p_ch_permitturnopen = &This->ch_permitturnopen;
	This->p_ch_motor = &This->ch_motor;
	EV_File(&This->SF);
	EV_File(&This->LF);
	EV_File(&This->CF);
	EV_File(&This->PCF);
	EV_File(&This->PTOF);
	EV_File(&This->MF);
	
	memset(&This->str_sql2[0] , 0x00 , sizeof(This->str_sql2));
	/* mysqlڑ */
	This->conn = mysql_init(NULL);
	if(!mysql_real_connect(This->conn, DBSERVER, DBID, DBPASSWORD, DBNAME, DBPORTNO, NULL, 0))
	{
		/* error */
		printf("%s\n", mysql_error(This->conn));
		exit(NG);
	}
	return;
}

/* databaseؒf */
void delete_EV_Log(struct EV_Log *This)
{
	mysql_close(This->conn);
	return;
}

/* databaseL^ */
void OnLog(struct EV_Log *This, Thread *th)
{
	This->i_safety = 0;
	snprintf(This->str_sql1, sizeof(This->str_sql1), "select * from s_log order by lg_ymd desc, lg_hms desc limit 1;" );
	mysql_query(This->conn , This->str_sql1);
	This->resp = mysql_use_result(This->conn);
	if((This->row = mysql_fetch_row(This->resp)) != NULL )
	{
		/* OSafety(S)DatabaseL^̎ */
		This->i_safety = (int) This->row[2][0];
		
		/* Debug */
		/* printf("\n%d %d : %s" , atoi(This->row[0]), atoi(This->row[1]), This->row[2]); */
	}
	mysql_free_result(This->resp);
	
	myDateTime(&This->mydate, &This->mytime);
	Read(&This->SF, "Safety.txt\0", This->p_ch_safety);
	ReadString(&This->LF, "Limit.txt\0", This->p_str_limit, 9);
	Read(&This->CF, "Command.txt\0", This->p_ch_command);
	Read(&This->PCF, "PermitCommand.txt\0", This->p_ch_permitcommand);
	Read(&This->PTOF, "PermitTurnOpen.txt\0", This->p_ch_permitturnopen);
	Read(&This->MF, "Motor.txt\0", This->p_ch_motor);
	
	sprintf(This->str_sql2, "insert into s_log(lg_ymd, lg_hms, lg_safety, lg_limit, lg_command, lg_permitcommand, lg_permitturnopen, lg_motor) values ( %ld, %ld, '%c', '%s', '%c', '%c', '%c', '%c');", This->mydate, This->mytime, This->ch_safety, This->p_str_limit, This->ch_command, This->ch_permitcommand, This->ch_permitturnopen, This->ch_motor);
	
	/* Debug */
	/* printf("\n%s\n", This->str_sql2); */
	
	mysql_query(This->conn, This->str_sql2);
	
	/* OSafety(S)̋L^r(Run ^])ǂ */
	if(This->i_safety - ((int) 'r') == 0)
	{
		/* ݂Safety(S)̋L^s(Stop ~)ǂ */
		if(This->ch_safety == 's')
		{
			/* ~bZ[W̃[ʕ */
			emergency();
		}
	}
	
	if(This->ch_command == 'q'){
		delete_(th);
	}
	return;
}

#ifdef USE_CENTOS
/* ~bZ[W̃[ʕ */
void emergency(void)
{
	/* \PbgfBXNv^ */
	int sds;
	FILE *fp;
	/*T[ovZX̃\PbgAhX */
	struct sockaddr_in server;
	/* zXg */
	struct hostent *hp;
	char buf[BUFSIZE];
	int i_buf;
	char ch_buf;
	
	/* ʃNA */
	CLEAR;
	
	/* \Pbg̍쐬 */
	if((sds = socket(PF_INET, SOCK_STREAM, 0)) == ERR)
	{
		perror("client: socket");
		exit(NG);
	}
	/* T[ȍi[ */
	memset((void*)&server, 0, sizeof(server));
	server.sin_family = PF_INET;
	server.sin_addr.s_addr = inet_addr(SERVER_NAME);
	/* |[gԍ25 */
	server.sin_port = htons(25);
	printf("%d\r\n", server.sin_family);
	  
	/* IPAhX̐ݒ */
	hp = gethostbyname(MAIL_FROM_SERVER);
	memcpy(&(server.sin_addr), hp->h_addr_list[0], hp->h_length);
	  
	/* T[oɐڑ */
	if(connect(sds, (struct sockaddr *)&server, sizeof(server))==ERR)
	{
		perror("client: connect");
		exit(NG);
	}
	read(sds, buf, sizeof(buf));
	printf("%s\r\n", buf);
	
	/* HELȎM */
	strcpy(buf, "HELO ");
	strcat(buf, MAIL_FROM_HOST); 
	strcat(buf, "\r\n\0");
	printf("%s", buf);
	write(sds, buf, strlen(buf));
	memset(&buf[0] , 0x00 , sizeof(buf));
	read(sds, buf, sizeof(buf));
	printf("%s", buf);
	
	/* MAIL FROM̑M */ 
	strcpy(buf, "MAIL FROM:");
	strcat(buf, MAIL_FROM_HOST); 
	strcat(buf, "\r\n\0"); 
	printf("%s", buf);
	write(sds, buf, strlen(buf));
	memset(&buf[0] , 0x00 , sizeof(buf));
	read(sds, buf, sizeof(buf));
	printf("%s", buf);
	
	/* RCPT TȎM */
	strcpy(buf, "RCPT TO:");
	strcat(buf, RCPT_TO_HOST_AT_SERVER);
	strcat(buf, "\r\n\0");
	printf("%s", buf);
	write(sds, buf, strlen(buf));
	memset(&buf[0] , 0x00 , sizeof(buf));
	read(sds, buf, sizeof(buf));
	printf("%s", buf);
	
	/* DATA ̑M */
	strcpy(buf, "DATA\r\n\0");
	printf("%s", buf);
	write(sds, buf, strlen(buf));
	memset(&buf[0] , 0x00 , sizeof(buf));
	read(sds, buf, sizeof(buf));
	printf("%s", buf);
	i_buf = 0;
	if((fp = fopen(SEND_DATA, "r")) != NULL)
	{
		strcpy(buf, "");
		while((ch_buf = fgetc(fp)) != EOF)
		{
			buf[i_buf++] = ch_buf;
		}
		fclose(fp);
		strcat(buf, "\r\n.\r\n\0");
		/* ~bZ[Wʕ */
		printf("%s", buf);
		write(sds, buf, strlen(buf));
		memset(&buf[0] , 0x00 , sizeof(buf));
		read(sds, buf, sizeof(buf));
		printf("%s", buf);
	}
	
	strcpy(buf, "QUIT\r\n\0");
	printf("%s", buf);
	write(sds, buf, strlen(buf));
	memset(&buf[0] , 0x00 , sizeof(buf));
	read(sds, buf, sizeof(buf));
	printf("%s", buf);
	
	return;
}
#endif
#ifdef USE_RASPBIAN
/* ~bZ[W̃[ʕ */
void emergency(void)
{
	/* vZXp */
	pid_t p;
	
	p = fork(); /* vZX */
	if(p == 0) /* qvZX */
	{
		/* ~bZ[Wʕ */
		system("echo An EV is stopped emergency! | mail -s \"This is from Raspberry Pi.\" info@hidemine.ciao.jp");
		printf("An EV is stopped emergency!");
		
		exit(OK); /* qvZXI */
	}
	
	return;
}
#endif
