/* EV_Puls.c */

#include "C.h"
#include "EV_Puls.h"

void EV_Set(int addressDataSet, int dataSet, int addressClockSet,
 int clockSet){
#ifndef USE_BCC
	/* address data set */
	if(addressDataSet == 0){
		PB.DR &= 0xfe;
	}
	else if(addressDataSet == 1){
		PB.DR |= 0x01;
	}
	/* data set */
	if(dataSet == 0){
		PB.DR &= 0xfd;
	}
	else if(dataSet == 1){
		PB.DR |= 0x02;
	}
	/* address clock set */
	if(addressClockSet == 0){
		PB.DR &= 0xfb;
	}
	else if(addressClockSet == 1){
		PB.DR |= 0x04;
	}
	/* clock set */
	if(clockSet == 0){
		PB.DR &= 0xf7;
	}
	else if(clockSet == 1){
		PB.DR |= 0x08;
	}
	/* disable set */
	PB.DR &= 0xef;
#endif
#ifdef USE_RASPBIAN
	/* address data set */
	digitalWrite(GPIO16, addressDataSet);
	/* data set */
	digitalWrite(GPIO17, dataSet);
	/* address clock set */
	digitalWrite(GPIO18, addressClockSet);
	/* clock set */
	digitalWrite(GPIO19, clockSet);
	/* disable set */
	digitalWrite(GPIO20, 0);
#endif
	return;
}

void EV_EnableSet(void){
#ifndef USE_BCC
	/* address data set */
	PB.DR &= 0xfe;
	/* data set */
	PB.DR &= 0xfd;
	/* address clock set */
	PB.DR &= 0xfb;
	/* clock set */
	PB.DR &= 0xf7;
	/* enable set */
	PB.DR |= 0x10;
#endif
#ifdef USE_RASPBIAN
	/* address data set */
	digitalWrite(GPIO16, 0);
	/* data set */
	digitalWrite(GPIO17, 0);
	/* address clock set */
	digitalWrite(GPIO18, 0);
	/* clock set */
	digitalWrite(GPIO19, 0);
	/* enable set */
	digitalWrite(GPIO20, 1);
#endif
	return;
}

int EV_AddressSet(Thread *th, int base, int address){
	int Ret;
	Ret = NG;
	if(th->count == base){
		EV_Set(address, 0, 0, 0);
		th->count++;
		Ret = OK;
	}
	else if(th->count == base + 1){
		EV_Set(address, 0, 1, 0);
		th->count++;
		Ret = OK;
	}
	return Ret;
}

int EV_DataSet(Thread *th, int base, int data){
	int Ret;
	Ret = NG;
	if(th->count == base){
		EV_Set(0, data, 0, 0);
		th->count++;
		Ret = OK;
	}
	else if(th->count == base + 1){
		EV_Set(0, data, 0, 1);
		th->count++;
		Ret = OK;
	}
	return Ret;
}

void EV_AddressDataSet(struct EV_Puls *puls, Thread *th,
 int address_1, int address_2, int address_3, int address_4,
 int data_1, int data_2, int data_3, int data_4){
	if(EV_AddressSet(th, 0, address_1) == OK);
	else if(EV_AddressSet(th, 2, address_2) == OK);
	else if(EV_AddressSet(th, 4, address_3) == OK);
	else if(EV_AddressSet(th, 6, address_4) == OK);
	else if(EV_DataSet(th, 8, data_1) == OK);
	else if(EV_DataSet(th, 10, data_2) == OK);
	else if(EV_DataSet(th, 12, data_3) == OK);
	else if(EV_DataSet(th, 14, data_4) == OK);
	else{
		EV_EnableSet();
		th->count = 0;
		switch(puls->Command){
		case 'q':
#ifndef USE_BCC
			/* address data set */
			PB.DR &= 0xfe;
			/* data set */
			PB.DR &= 0xfd;
			/* address clock set */
			PB.DR &= 0xfb;
			/* clock set */
			PB.DR &= 0xf7;
			/* disable set */
			PB.DR &= 0xef;
#endif
#ifdef USE_RASPBIAN
			/* address data set */
			digitalWrite(GPIO16, 0);
			/* data set */
			digitalWrite(GPIO17, 0);
			/* address clock set */
			digitalWrite(GPIO18, 0);
			/* clock set */
			digitalWrite(GPIO19, 0);
			/* disable set */
			digitalWrite(GPIO20, 0);
#endif
			delete_(th);
			break;
		default:
			break;
		}
	}
	return;
}

void EV_Puls(struct EV_Puls *This, Thread *th){
	This->p_ch = &This->ch;
	This->p_Command = &This->Command;
	EV_File(&This->MF);
	EV_File(&This->CF);
#ifndef USE_BCC
	PB.DDR = 0xff; /* bit7..0 out */
	PB.DR |= 0xff;
#endif
#ifdef USE_RASPBIAN
	if (wiringPiSetupGpio() == -1) exit(NG);
	pinMode(GPIO16, OUTPUT);
	pinMode(GPIO17, OUTPUT);
	pinMode(GPIO18, OUTPUT);
	pinMode(GPIO19, OUTPUT);
	pinMode(GPIO20, OUTPUT);
#endif
	return;
}

void OnPuls(struct EV_Puls *This, Thread *th){
	if(th->count == 0){
		/* ߓ */
		Command_Read(&This->CF, This->p_Command);
		/* [^[߉ */
		Read(&This->MF, "Motor.txt\0", This->p_ch);
	}
	switch(This->ch){
	case 's':
		EV_AddressDataSet(This, th, 0, 1, 1, 1, 0, 0, 0, 0);
		break;
	case 'j':
		EV_AddressDataSet(This, th, 0, 1, 1, 1, 0, 0, 0, 1);
		break;
	case 'u':
		EV_AddressDataSet(This, th, 0, 1, 1, 1, 0, 0, 1, 0);
		break;
	case 'U':
		EV_AddressDataSet(This, th, 0, 1, 1, 1, 0, 0, 1, 1);
		break;
	case 'k':
		EV_AddressDataSet(This, th, 0, 1, 1, 1, 0, 1, 0, 0);
		break;
	case 'd':
		EV_AddressDataSet(This, th, 0, 1, 1, 1, 0, 1, 0, 1);
		break;
	case 'D':
		EV_AddressDataSet(This, th, 0, 1, 1, 1, 0, 1, 1, 0);
		break;
	case 'h':
		EV_AddressDataSet(This, th, 0, 1, 1, 1, 0, 1, 1, 1);
		break;
	case 'o':
		EV_AddressDataSet(This, th, 0, 1, 1, 1, 1, 0, 0, 0);
		break;
	case 'O':
		EV_AddressDataSet(This, th, 0, 1, 1, 1, 1, 0, 0, 1);
		break;
	case 't':
		EV_AddressDataSet(This, th, 0, 1, 1, 1, 1, 0, 1, 0);
		break;
	case 'c':
		EV_AddressDataSet(This, th, 0, 1, 1, 1, 1, 0, 1, 1);
		break;
	case 'C':
		EV_AddressDataSet(This, th, 0, 1, 1, 1, 1, 1, 0, 0);
		break;
	default:
		break;
	}
	return;
}
