/************************************************************************/
/*	   H8/3048F Include File							  				*/
/************************************************************************/
struct st_sam { 				/* struct DMAC	*/
	void			*MAR;		/* MAR			*/
	unsigned int	ETCR;		/* ETCR 		*/
	unsigned char 	IOAR;		/* IOAR 		*/
	unsigned char 	DTCR;		/* DTCR			*/
};

struct st_fam { 				/* struct DMAC	*/
	void			*MARA;		/* MARA 		*/
	unsigned int	ETCRA;		/* ETCRA		*/
	unsigned char 	IOARA;		/* IOAR 		*/
	unsigned char	DTCRA;		/* DTCRA		*/
	void		  	*MARB;		/* MARB 		*/
	unsigned int	ETCRB;		/* ETCRB		*/
	unsigned char 	IOARB;		/* IOAR 		*/
	unsigned char	DTCRB;		/* DTCRB		*/
};

struct st_itu { 				/* struct ITU	*/
	unsigned char	TSTR;		/* TSTR 		*/
	unsigned char	TSNC;		/* TSNC 		*/
	unsigned char	TMDR;		/* TMDR 		*/
	unsigned char	TFCR;		/* TFCR 		*/
	char			wk[44]; 	/*				*/
	unsigned char	TOER;		/* TOER 		*/
	unsigned char	TOCR;		/* TOCR 		*/
};

struct st_itu0 {				/* struct ITU0	*/
	unsigned char	TCR;		/* TCR			*/
	unsigned char	TIOR;		/* TIOR 		*/
	unsigned char	TIER;		/* TIER 		*/
	unsigned char	TSR;		/* TSR			*/
	unsigned int 	TCNT;		/* TCNT 		*/
	unsigned int 	GRA;		/* GRA			*/
	unsigned int 	GRB;		/* GRB			*/
};

struct st_itu3 {				/* struct ITU3	*/
	unsigned char	TCR;		/* TCR			*/
	unsigned char	TIOR;		/* TIOR 		*/
	unsigned char	TIER;		/* TIER 		*/
	unsigned char	TSR;		/* TSR			*/
	unsigned int 	TCNT;		/* TCNT 		*/
	unsigned int 	GRA;		/* GRA			*/
	unsigned int 	GRB;		/* GRB			*/
	unsigned int 	BRA;		/* BRA			*/
	unsigned int 	BRB;		/* BRB			*/
	char 			wk[2];		/*				*/
};

struct st_tpc { 				/* struct TPC	*/
	unsigned char	TPMR;		/* TPMR 		*/
	unsigned char	TPCR;		/* TPCR 		*/
	unsigned char	NDERB;		/* NDERB		*/
	unsigned char	NDERA;		/* NDERA		*/
	unsigned char	NDRB1;		/* NDRB (H'A4)	*/
	unsigned char	NDRA1;		/* NDRA (H'A5)	*/
	unsigned char	NDRB2;		/* NDRB (H'A6)	*/
	unsigned char	NDRA2;		/* NDRA (H'A7)	*/
};

struct st_rfshc {				/* struct RFSHC */
	unsigned char	RFSHCR;		/* RFSHCR		*/
	unsigned char	RTMCSR;		/* RTMCSR		*/
	unsigned char	RTCNT;		/* RTCNT		*/
	unsigned char	RTCOR;		/* RTCOR		*/
};

struct st_sci { 				/* struct SCI	*/
	unsigned char	SMR;		/* SMR			*/
	unsigned char 	BRR;		/* BRR			*/
	unsigned char	SCR;		/* SCR			*/
	unsigned char 	TDR;		/* TDR			*/
	unsigned char	SSR;		/* SSR			*/
	unsigned char 	RDR;		/* RDR			*/
	char			wk[2];		/*				*/
};

struct st_p1 {					/* struct P1	*/
	unsigned char	DDR;		/* P1DDR		*/
	char			wk; 		/*				*/
	unsigned char	DR;			/* P1DR 		*/
};

struct st_p2 {					/* struct P2	*/
	unsigned char	DDR;		/* P2DDR		*/
	char			wk1;		/*				*/
	unsigned char	DR;			/* P2DR 		*/
	char			wk2[20];	/*				*/
	unsigned char	PCR;		/* P2PCR		*/
};

struct st_p4 {					/* struct P4	*/
	unsigned char	DDR;		/* P4DDR		*/
	char			wk1;		/*				*/
	unsigned char	DR;			/* P4DR 		*/
	char			wk2[18];	/*				*/
	unsigned char	PCR;		/* P4PCR		*/
};

struct st_p5 {					/* struct P5	*/
	unsigned char	DDR;		/* P5DDR		*/
	char			wk1;		/*				*/
	unsigned char	DR;			/* P5DR 		*/
	char			wk2[16];	/*				*/
	unsigned char	PCR;		/* P5PCR		*/
};

struct st_p6 {					/* struct P6	*/
	unsigned char	DDR;		/* P6DDR		*/
	char			wk; 		/*				*/
	unsigned char	DR;			/* P6DR 		*/
};

struct st_p7 {					/* struct P7	*/
	unsigned char	DR;			/* P7DR 		*/
};

struct st_p8 {					/* struct P8	*/
	unsigned char	DDR;		/* P8DDR		*/
	char			wk; 		/*				*/
	unsigned char	DR;			/* P8DR 		*/
};

struct st_p9 {					/* struct P9	*/
	unsigned char	DDR;		/* P9DDR		*/
	char			wk; 		/*				*/
	unsigned char	DR;			/* P9DR 		*/
};

struct st_da {					/* struct D/A	*/
	unsigned char	STCR;		/* DASTCR		*/
	char			wk[127];	/*				*/
	unsigned char	DR0;		/* DADR0		*/
	unsigned char	DR1;		/* DADR1		*/
	unsigned char	CR;			/* DACR 		*/
};

struct st_ad {					/* struct A/D	*/
	unsigned int	DRA;		/* ADDRA		*/
	unsigned int	DRB;		/* ADDRB		*/
	unsigned int	DRC;		/* ADDRC		*/
	unsigned int	DRD;		/* ADDRD		*/
	unsigned char	CSR;		/* ADCSR		*/
	unsigned char	CR;			/* ADCR 		*/
};

struct st_bsc { 				/* struct BSC	*/
	unsigned char	CSCR;		/* CSCR 		*/
	char			wk1[140];	/*				*/
	unsigned char	ABWCR;		/* ABWCR		*/
	unsigned char	ASTCR;		/* ASTCR		*/
	unsigned char	WCR;		/* WCR			*/
	unsigned char	WCER;		/* WCER 		*/
	char			wk2[3]; 	/*				*/
	unsigned char	BRCR;		/* BRCR 		*/
};

struct st_intc {				/* struct INTC	*/
	unsigned char	ISCR;		/* ISCR 		*/
	unsigned char	IER;		/* IER			*/
	unsigned char	ISR;		/* ISR			*/
	char			wk; 		/*				*/
	unsigned char	IPRA;		/* IPRA 		*/
	unsigned char	IPRB;		/* IPRB 		*/
};

#define DMAC0A	(*(volatile struct st_sam	*)0xFFFF20) /* DMAC 0A Addr */
#define DMAC0B	(*(volatile struct st_sam	*)0xFFFF28) /* DMAC 0B Addr */
#define DMAC1A	(*(volatile struct st_sam	*)0xFFFF30) /* DMAC 1A Addr */
#define DMAC1B	(*(volatile struct st_sam	*)0xFFFF38) /* DMAC 1B Addr */
#define DMAC0	(*(volatile struct st_fam	*)0xFFFF20) /* DMAC 0  Addr */
#define DMAC1	(*(volatile struct st_fam	*)0xFFFF30) /* DMAC 1  Addr */
#define ITU 	(*(volatile struct st_itu	*)0xFFFF60) /* ITU	 Address*/
#define ITU0	(*(volatile struct st_itu0	*)0xFFFF64) /* ITU0  Address*/
#define ITU1	(*(volatile struct st_itu0	*)0xFFFF6E) /* ITU1  Address*/
#define ITU2	(*(volatile struct st_itu0	*)0xFFFF78) /* ITU2  Address*/
#define ITU3	(*(volatile struct st_itu3	*)0xFFFF82) /* ITU3  Address*/
#define ITU4	(*(volatile struct st_itu3	*)0xFFFF92) /* ITU4  Address*/
#define TPC 	(*(volatile struct st_tpc	*)0xFFFFA0) /* TPC	 Address*/
#define RFSHC	(*(volatile struct st_rfshc *)0xFFFFAC) /* RFSHC Address*/
#define SCI0	(*(volatile struct st_sci	*)0xFFFFB0) /* SCI0  Address*/
#define SCI1	(*(volatile struct st_sci	*)0xFFFFB8) /* SCI1  Address*/
#define P1		(*(volatile struct st_p1	*)0xFFFFC0) /* P1	 Address*/
#define P2		(*(volatile struct st_p2	*)0xFFFFC1) /* P2	 Address*/
#define P3		(*(volatile struct st_p1	*)0xFFFFC4) /* P3	 Address*/
#define P4		(*(volatile struct st_p4	*)0xFFFFC5) /* P4	 Address*/
#define P5		(*(volatile struct st_p5	*)0xFFFFC8) /* P5	 Address*/
#define P6		(*(volatile struct st_p6	*)0xFFFFC9) /* P6	 Address*/
#define P7		(*(volatile struct st_p7	*)0xFFFFCE) /* P7	 Address*/
#define P8		(*(volatile struct st_p8	*)0xFFFFCD) /* P8	 Address*/
#define P9		(*(volatile struct st_p9	*)0xFFFFD0) /* P9	 Address*/
#define PA		(*(volatile struct st_p1	*)0xFFFFD1) /* PA	 Address*/
#define PB		(*(volatile struct st_p1	*)0xFFFFD4) /* PB	 Address*/
#define DA		(*(volatile struct st_da	*)0xFFFF5C) /* D/A	 Address*/
#define AD		(*(volatile struct st_ad	*)0xFFFFE0) /* A/D	 Address*/
#define BSC 	(*(volatile struct st_bsc	*)0xFFFF5F) /* BSC	 Address*/
#define FLMCR	(*(volatile unsigned char  *)0xFFFF40) /* FLMCR Address*/
#define EBR1	(*(volatile unsigned char 	*)0xFFFF42) /* EBR1  Address*/
#define EBR2	(*(volatile unsigned char 	*)0xFFFF43) /* EBR2  Address*/
#define RAMCR	(*(volatile unsigned char  *)0xFFFF48) /* RAMCR Address*/
#define DIVCR	(*(volatile unsigned char  *)0xFFFF5D) /* DIVCR Address*/
#define MSTCR	(*(volatile unsigned char  *)0xFFFF5E) /* MSTCR Address*/
#define MDCR	(*(volatile unsigned char 	*)0xFFFFF1) /* MDCR  Address*/
#define SYSCR	(*(volatile unsigned char *)0xFFFFF2) /* SYSCR Address*/
#define INTC	(*(volatile struct st_intc	*)0xFFFFF4) /* INTC  Address*/
#define st_itu1 st_itu0 						/* Change Struct ITU1	*/
#define st_itu2 st_itu0 						/* Change Struct ITU2	*/
#define st_itu4 st_itu3 						/* Change Struct ITU4	*/
#define st_p3	st_p1							/* Change Struct P3->P1 */
#define st_pa	st_p1							/* Change Struct PA->P1 */
#define st_pb	st_p1							/* Change Struct PB->P1 */
