/*

	USB N9604 Rg[
											(C)2002 C.I.M

*/

#include	<stdio.h>
#include	<string.h>
#include	"usbn9602.h"
#include	"h83048.h"

extern	void PrintSCI(const char *fmt, ...);		/* sci.c */

static void RegisterSet();
static void ResetUSB();
static void WakeupUSB();

static void rx0();
static void rx1();
static void tx0();
static void tx1();
static void nako0();
static void nako1();
static void naki0();
static void naki1();

static void clrfeature();
static void setfeature();
static void getdescriptor();
static void send_desc_sub(void *ptr,int size);
static void send_desc();
static void getstatus();
static void setconfiguration();

static void SetStallUSB(int adr);
static void ClearStallUSB(int adr);
static void FlushRXC(int no);
static void FlushTXC(int no);
static void TxTogle(int no);

static void WriteUSB(int adr,int data);
static unsigned char ReadUSB(int adr);
static int ReadUSBBurst(int adr,int adr2,char *buff,int cnt);
static int WriteUSBBurst(int adr,int adr2,char *buff,int cnt);

/*---------------------------------*/
static int SendTX1();

/*---------------------------------*/
int get_inbufflen(void);
void init_usbbuff(void);
int write_inbuff(char *p,int size);
int get_outbufflen(void);
int write_buff(char *p,int size);
int read_outbuff(char *p,int size);
/*---------------------------------*/

static	unsigned char	usbevent;					/* USB荞݃Cxg		*/
static	unsigned char	SETADDR;					/* AhXZbg 			*/
static	unsigned char	configno;					/* RtBO[VNO	*/
static	unsigned char	usbbuff[64];				/* ǂݍ݃obt@			*/
static	unsigned char	rx1buff[64];
static	unsigned char	rx2buff[64];
static	unsigned char	STALLD;						/* ECP̏				*/
static	unsigned char	DATA0_1;					/* USB_TXTGL̃tO		*/
static	char			senddesc;					/* 1 = fBXNv^M	*/
static	int				desc_size;					/* fBXNv^MTCY	*/
static	char			*desc_ptr;					/* fBXNv^|C^	*/


static	const unsigned char	epctbl[8] = {USB_EPC0,USB_EPC1,USB_EPC2,USB_EPC3,USB_EPC4,USB_EPC5,USB_EPC6,USB_EPC0};
static int	txcreg[4] = {USB_TXC0,USB_TXC1,USB_TXC2,USB_TXC3};
static int rxcreg[4] = {USB_RXC0,USB_RXC1,USB_RXC2,USB_RXC3};

/*------------------------------------------------------------*/
/*------------------------------------------------------------*/
static const unsigned char dev_desc[] = {
	0x12,				/* length of this desc.							*/
	0x01,				/* foCXEfBXNv^ 1 					*/
	0x00,0x01,			/* USB Version 1.0								*/
	0x00,				/* device class	NX					 	*/
	0x00,				/* device subclass								*/
	0x00,				/* device protocol								*/
	0x08,				/* EP0̍őpPbgTCY 						*/
	0xfe,0xff,			/* vendor ID	TvȂ̂łƂ肠		*/
	0x10,0x00,			/* product ID									*/
	0x01,0x00,			/* revision ID									*/
	0x01,				/* index of manuf. string						*/
	0x01,				/* index of prod.  string						*/
	0x02,				/* index of ser. # string						*/
	0x01				/* bNumConfigurations 							*/
};

/* RtBO[VfBXNv^ */
static const unsigned char cfg_desc[] = {
	0x09,				/* length of this desc.							*/
	0x02,				/* RtBO[VEfBXNv^ 		*/
	9+9+7*3,			/* C^[tF[X^Gh|CgfBXNv^̍v CFG + IF + EP*3 */
	0x00,				/* 												*/
	0x01,				/* C^[tF[X 1 						*/
	0x01,				/* RtBO[V 1						*/
	0x00,				/* index of config. string						*/
	0xc0,				/* attr.: self powered	D6=ȓd				*/
	100,				/*	;max power (100 mA)							*/
/*};*/
/*static const unsigned char if_desc[] = {*/
	0x09,				/* length of this desc.							*/
	0x04,				/* INTERFACE descriptor							*/
	0x00,				/* interface number								*/
	0x00,				/* alternate setting							*/
	0x03,				/* # of (non 0) endpoints						*/
	0x00,				/* interface class								*/
	0x00,				/* interface subclass							*/
	0x00,				/* interface protocol							*/
	0x03,				/* index of intf. string						*/
/*};*/
/*static const unsigned char endp_desc[] = {*/
	/* pipe 0 */
	7,					/* length of this desc.							*/
	5,					/* ENDPOINT descriptor							*/
	0x81,				/* address (IN)									*/
	0x02,				/* attributes  (BULK)							*/
	0x40,0x00,			/* max packet size (64)							*/
	255,				/* interval (ms)								*/
	/* pipe 1 */
	7,					/* length of this desc.							*/
	5,					/* ENDPOINT descriptor							*/
	0x02,				/* address (OUT)								*/
	0x02,				/* attributes  (BULK)							*/
	0x40,0x00,			/* max packet size (64)							*/
	255,				/* interval (ms)								*/

	/* pipe 2 (not use) */
	7,					/* length of this desc.							*/
	5,					/* ENDPOINT descriptor							*/
	0x83,				/* address (IN)									*/
	0x02,				/* attributes  (BULK)							*/
	0x40,0x00,			/* max packet size (64)							*/
	255,				/* interval (ms)								*/
};


static const char lang_data[] = {
		4,3,9,4			/* LANGID (English)								*/
};

static const char mfg_str[] = {
		18,3,
		'U',0,'S',0,'B',0,' ',0,'T',0,'E',0,'S',0,'T',0,
};


static const char nbr_str[] = {
	8,3,
	'1',0,'.',0,'0',0,
};

static const char int_str[] = {
	34,3,
	'U',0,'S',0,'B',0,' ',0,
	'T',0,'E',0,'S',0,'T',0,' ',0,'P',0,'R',0,'O',0,'G',0,'R',0,'A',0,'M',0,
};

static void wait(int c)
{
	int		i,j;
	for(j=0;j<c;j++)
	{
		for(i=0;i<0x682;i++)
		{
		}
	}
}

/*------------------------------------------------------------*/
/* USB */
void InitUSB()
{
	init_usbbuff();
	ResetUSB();
	RegisterSet();
	WakeupUSB();
/*	PrintSCI(" REV = %d\n",ReadUSB(USB_RID)); */
/*	PrintSCI(" CLOCK = %02X\n",ReadUSB(USB_CCONF)); */
	
}

static void RegisterSet()
{
	STALLD = 0;
	senddesc = 0;
	DATA0_1 = 0;
	SETADDR = 0;

	WriteUSB(USB_FAR,USB_AD_EN+0);				/* AhX	*/
	WriteUSB(USB_EPC0,USB_EP_EN);				/* EP0Ȱ		*/
	WriteUSB(USB_NAKMSK,USB_NAK_O0);			/* NAK MASK	*/
	WriteUSB(USB_TXMSK,USB_TXFIFO0+USB_TXFIFO1+USB_TXFIFO2+USB_TXFIFO3);	/* TX MASK */
	WriteUSB(USB_RXMSK,USB_RXFIFO0+USB_RXFIFO1+USB_RXFIFO2+USB_RXFIFO3);	/* RX MASK */
	WriteUSB(USB_ALTMSK,USB_SD3+USB_RESET_A);		/* ALT MASK */
	WriteUSB(USB_MAMSK,USB_INTR_E+USB_RX_EV+USB_NAK+USB_TX_EV+USB_ALT);		/* MAIN MASK */
	FlushTXC(0);
	FlushRXC(1);
	FlushTXC(1);
	WriteUSB(USB_TXC1,0);
	WriteUSB(USB_RXC1,0);
	WriteUSB(USB_RXC0,USB_RX_EN);				/* RX0Ȱ		*/
}

static void ResetUSB()
{
	WriteUSB(USB_MCNTRL,USB_SRST+USB_VGE);				/* USBZbg 3.3V */
	wait(100);											/* 100msec */
	WriteUSB(USB_MCNTRL,USB_INT_L_P+USB_VGE);			/* ݂active low push pull */
	WriteUSB(USB_CCONF,USB_CLKDIV-1);					/* 48MHz/4 = 12MHz */
}

static void WakeupUSB()
{
	WriteUSB(USB_NFSR,USB_OPR_ST);						/* ɂ */
	WriteUSB(USB_MCNTRL,USB_INT_L_P+USB_NAT+USB_VGE);	/* USBɰނ𓮍ɂ */
}

/* USB|[gf[^\ */
/* [hƁAXe[^Xς郌WX^̂Œ */
void DispUSBPort()
{
		int		i,j;
		PrintSCI("00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F\n");
		for(j=0;j<4;j++)
		{
			for(i=0;i<16;i++)
				PrintSCI("%02X ",ReadUSB(i+j*16));
			PrintSCI("\n");
		}
}

/*------------------------------------------------------------*/
/* USB荞 */
#ifdef	__GNUC__
void usb_int()  __attribute__ ((interrupt_handler));
#endif
void usb_int()
{
	unsigned char	nakevent,rxevent,txevent,altevent;
	char	reg;


	usbevent = ReadUSB(USB_MAEV);

	if( usbevent & USB_NAK )
	{
		nakevent = ReadUSB(USB_NAKEV);
		if( nakevent & USB_NAK_O0 )
		{
			nako0();
		}
		if( nakevent & USB_NAK_O1 )
		{
			nako1();
		}
		else if( nakevent & USB_NAK_I0 )
		{
			naki0();
		}
		else if( nakevent & USB_NAK_I1 )
		{
			naki1();
		}
	}
	else if( usbevent & USB_RX_EV )
	{
		rxevent = ReadUSB(USB_RXEV);
		if( rxevent & USB_RXFIFO0 )
		{
			rx0();
		}
		else if( rxevent & USB_RXFIFO1 )
		{
			rx1();
		}
	}
	else if( usbevent & USB_TX_EV )
	{
		txevent = ReadUSB(USB_TXEV);
		if( txevent & USB_TXFIFO0 )
		{
			tx0();
		}
		else if( txevent & USB_TXFIFO1 )
		{
			tx1();
		}
	}
	else if( usbevent & USB_ALT )
	{
		altevent = ReadUSB(USB_ALTEV);
		if( altevent & USB_RESET_A )
		{
			/* Zbg */
			RegisterSet();
			WakeupUSB();
		}
		else if( altevent & USB_SD3 )
		{
			/* TXyh */
			WriteUSB(USB_ALTMSK,USB_RESUME_A+USB_RESET_A);	/* ALTMSK		*/
			WriteUSB(USB_NFSR,USB_SUS_ST);					/* ɰނ	*/
			
		}
		else if( altevent & USB_RESUME_A )
		{
			/* W[ */
			WriteUSB(USB_ALTMSK,USB_SD3+USB_RESET_A);		/* ALTMSK			*/
			WriteUSB(USB_NFSR,USB_OPR_ST);					/* ɰނ𓮍\ɂ	*/
		}
	}
}

/*==========================================================================
							RXCxg̏								
==========================================================================*/
/* RX0(system) */
/*
 NGXgR[h̎擾 
		0 byte
			D7 ... f[^ 0=zXg->foCX , 1=foCX->zXg 
			D6-D5 ... ^Cv
					0:W , 1:NX , 2:x_ , 3:\
			D4-D0 ... M
					0:foCX , 1:C^[tFCX , 2:Gh|Cg , 3:̑ 
		1 byte
			̃NGXg
		2 byte
			value
		2 byte
			index
		2 byte
			length
*/
static void rx0()
{
	unsigned char	rxstat;
	rxstat = ReadUSB(USB_RXS0);
	if( rxstat & USB_SETUP_RX )
	{
		ReadUSBBurst(USB_RXD0,USB_RXS0,(char*)usbbuff,8);
		FlushRXC(0);
		FlushTXC(0);
		ClearStallUSB(USB_EPC0);
		if( (usbbuff[0] & 0x60) == 0 )
		{
			/* WNGXg */
			switch( usbbuff[1] )
			{
				case	USB_CLEAR_FEATURE :
					clrfeature();
					break;
				case	USB_GET_CONFIGURATION :
					WriteUSB(USB_TXD0,configno);
					break;
				case	USB_GET_DESCRIPTOR :
					getdescriptor();
					break;
				case	USB_GET_STATUS :
					getstatus();
					break;
				case	USB_GET_INTERFACE :
					WriteUSB(USB_TXD0,0);
					break;
				case	USB_SET_ADDRESS :
					WriteUSB(USB_EPC0,USB_DEF);
					SETADDR = usbbuff[2]|USB_AD_EN;
					WriteUSB(USB_FAR,SETADDR);
					break;
				case	USB_SET_CONFIGURATION :
					setconfiguration();
					break;
				case	USB_SET_FEATURE :
					setfeature();
					break;
				case	USB_SET_INTERFACE :
					if( usbbuff[2] != 0 )
						SetStallUSB(USB_EPC0);
					break;
				default :
					/* ` */
					SetStallUSB(USB_EPC0);
					break;
			}
		}
		else if( (usbbuff[0] &0x60 ) ==  0x20 )
		{
			/* NXNGXg */
			SetStallUSB(USB_EPC0);
		}
		else if( (usbbuff[0] &0x60 ) ==  0x40 )
		{
			/* x_NGXg */
			SetStallUSB(USB_EPC0);
		}
		else
		{
			/* ` */
			SetStallUSB(USB_EPC0);
		}
		DATA0_1 |= 1;	/* SETUPȂ̂ް̗LɊ֌WDATA1ƂđM */
		TxTogle(0);
	}
	else
	{
		if( senddesc )
		{
			senddesc = 0;
		}
		FlushTXC(0);
		WriteUSB(USB_RXC0,USB_RX_EN);
	}
}

/*------------------------------------------------------------*/
/* RX1 M */
static void rx1()
{
	int			cnt;
	unsigned char	rxstat;
	rxstat = ReadUSB(USB_RXS1);			/* RX1Xe[^X擾 */
	if( !(rxstat & (USB_SETUP_RX|USB_RX_ERR)) )				/* SETUP,ERRORpPbgłȂ */
	{
		/* zXgf[^̎M */
		cnt = ReadUSBBurst(USB_RXD1,USB_RXS1,(char*)rx1buff,64);	/* FIFOf[^擾 */
		write_inbuff((char*)rx1buff,cnt);							/* Oobt@ɏ */
	}
	FlushRXC(1);						/* obt@tbV */
	WriteUSB(USB_RXC1,USB_RX_EN);		/* Mɐݒ			*/
}

/*------------------------------------------------------------*/
/* RX2 M(not use) */
static void rx2()
{
	unsigned char	rxstat;
	rxstat = ReadUSB(USB_RXS2);
}

/*==========================================================================
							TXCxg̏								
==========================================================================*/
/* TX0 MI */
static void tx0()
{
	unsigned char	txstat;
	txstat = ReadUSB(USB_TXS0);
	if( (txstat & USB_ACK_STAT) && (txstat & USB_TX_DONE) )
	{
		/* ok */
		FlushTXC(0);
		if( senddesc )
		{
			send_desc();
			TxTogle(0);					/* TX0M */
		}
		else
		{
			WriteUSB(USB_RXC0,USB_RX_EN);	/* RX0M */
		}
	}
	else
	{
		/* error ? */
	}
}

/*------------------------------------------------------------*/
/* TX1MI */
static void tx1()
{
	unsigned char	txstat;
	txstat = ReadUSB(USB_TXS1);
	if( (txstat & USB_ACK_STAT) && (txstat & USB_TX_DONE) )
	{
		/* 
			MIɎ̑Mf[^𑗐M悤ɂ
			Mf[^ꍇAHOSTɂ0oCgő
		*/
		SendTX1();
	}
	else
	{
		/* 
			TCY菬ǂݍ݂sꂽꍇAɂꍇ
		*/
	}
}

/*==========================================================================
							NAKCxg̏								
==========================================================================*/
/*
	NAKCxǵAG[ꍇȂǍđMꍇ
	NAK0ENABLEɂĂȂ̂ŁAȊO͏
*/
static void nako0()
{
}
static void nako1()
{
}
static void naki0()
{
}

static void naki1()
{
}


/*==========================================================================
							WNGXg̏							
==========================================================================*/
/* I@ */
static void clrfeature()
{
	if( (usbbuff[0] & 3) == 2 )
	{
		/* Gh|Cgf[^ */
		if((usbbuff[3]&7) != 0 )
			ClearStallUSB(epctbl[usbbuff[3]&7]);
		STALLD &= -1 ^ (1<<(usbbuff[3]&7));
	}
}
static void setfeature()
{
	if( (usbbuff[0]&3) == 2 )		/* ENDPOINT */
	{
		/* Gh|Cgf[^ */
		if((usbbuff[3]&7) != 0 )
			SetStallUSB(epctbl[usbbuff[3]&7]);
		STALLD |= (1<<(usbbuff[3]&7));
	}
}

/*------------------------------------------------------------*/
/* fBXNv^Ԃ */
static void getdescriptor()
{
	DATA0_1 &= 0xfe;
	switch( usbbuff[3] )
	{
		case	USB_DEVICE :
			send_desc_sub((void*)dev_desc,dev_desc[0]);
			break;
		case	USB_CONFIGURATION :
		{
			send_desc_sub((void *)cfg_desc,cfg_desc[2]);
			break;
		}
		case	USB_XSTRING :
		{
			switch( usbbuff[2] )
			{
				case	0 :
					send_desc_sub((void *)lang_data,lang_data[0]);
					break;
				case	1 :
					send_desc_sub((void *)mfg_str,mfg_str[0]);
					break;
				case	2 :
					send_desc_sub((void *)nbr_str,nbr_str[0]);
					break;
				case	3 :
					send_desc_sub((void *)int_str,int_str[0]);
					break;
			}
			break;
		}
		default :
		{
		}
	}
}

static void send_desc_sub(void *ptr,int size)
{
	desc_size = (usbbuff[7] << 8) + usbbuff[6];
	if( desc_size > size )	desc_size = size;	/* Mvobt@ȏ̓f[^𑗂Ȃ */
	desc_ptr = ptr;
	senddesc = 1;								/* fBXNv^MtO𗧂Ă */
	send_desc();
}

static void send_desc()
{
	int		sz;
	sz = 8;
	if( desc_size == 0 )	return;
	if( desc_size <= 8 )	sz = desc_size;
	sz = WriteUSBBurst(USB_TXD0,USB_TXS0,desc_ptr,sz);
	desc_size -= sz;
	desc_ptr += sz;
	if( desc_size == 0 )	senddesc = 0;
}
/*------------------------------------------------------------*/
/* Xe[^X */
static void getstatus()
{
	int		data,ep;
	data = usbbuff[0]&3;
	if( (data == 0) || (data == 1) )		/* DEVICE,INTERFACE */
	{
		WriteUSB(USB_TXD0,0);
		WriteUSB(USB_TXD0,0);
	}
	else if( data== 2)						/* Gh|Cg */
	{
		ep = usbbuff[3]&7;
		/* epSTALLԂ𑗐M */
		if( STALLD & (1<<ep) )	WriteUSB(USB_TXD0,1);
		else					WriteUSB(USB_TXD0,0);
	}
	else
	{
		WriteUSB(USB_TXD0,0);
	}
}

/*------------------------------------------------------------*/
static void setconfiguration()
{
	configno = usbbuff[2];
	if( configno == 0 )
	{
		WriteUSB(USB_EPC1,0);				/* EPC1gps */
		WriteUSB(USB_EPC2,0);				/* EPC2gps */
		WriteUSB(USB_EPC3,0);				/* EPC3gps */
		WriteUSB(USB_EPC4,0);				/* EPC4gps */
		WriteUSB(USB_EPC5,0);				/* EPC5gps */
		WriteUSB(USB_EPC6,0);				/* EPC6gps */
	}
	else
	{
		STALLD = 0;
		FlushTXC(1);
		WriteUSB(USB_EPC1,USB_EP_EN+01);			/* EPC1ڽ1ƂĲȰ */
		WriteUSB(USB_TXC1,USB_TX_EN|USB_TX_LAST);	/* TX1M */

		FlushRXC(1);
		WriteUSB(USB_EPC2,USB_EP_EN+02);			/* EPC2ڽ2ƂĲȰ */
		WriteUSB(USB_RXC1,USB_RX_EN);				/* RX1M */
		/*
			USB_TX_LAST𗧂ĂƁAREADXg[ȂȂB
			Af[^𑗂O̍ŏREAD0byteɂȂ܂B 
			host͕̃NGXg𓯎słȂ̂ŁA
			NGXgXg[̂͂܂̉B
		*/
	}
}

/*==========================================================================
								ėp[`								
==========================================================================*/
/* STALL̃ZbgƃNA */
static void SetStallUSB(int adr)
{
	WriteUSB(adr,ReadUSB(adr) | 0x80);
}

static void ClearStallUSB(int adr)
{
	WriteUSB(adr,ReadUSB(adr)&0x7f);
}

/* FIFÕtbV */
static void FlushRXC(int no)
{
	WriteUSB(rxcreg[no],USB_FLUSH);
}

static void FlushTXC(int no)
{
	int		d;
	d = ReadUSB(txcreg[no]);
	d |= USB_FLUSH;
	WriteUSB(txcreg[no],d);
}

/* MItOZbg */
/* reg = USB_TXC0`6	*/
static void TxTogle(int no)
{
	unsigned char	d;
	d = USB_TX_EN;
	if( DATA0_1 & (1<<no) )	d |= USB_TX_TOGL;
	else					d &= ~USB_TX_TOGL;
	d |= USB_TX_LAST;
	WriteUSB(txcreg[no],d);
	DATA0_1 ^= (1<<no);
}

/*------------------------------------------------------------*/
/* USB̃AhXǂݍ */
static unsigned char ReadUSB(int adr)
{
	USB9602R = (unsigned char)adr;
	return( USB9602D );
}
/* USB̃AhX֏ */
static void WriteUSB(int adr,int data)
{
	USB9602R = (unsigned char)adr;
	USB9602D = (unsigned char)data;
}


/* o[Xgg] */
static int ReadUSBBurst(int adr,int adr2,char *buff,int cnt)
{
	int		i;
	int		rcnt;
	USB9602R = (unsigned char)adr;
	for(rcnt=0,i=0;i<cnt;i++)
	{
		if( (ReadUSB(adr2) & 0xf) == 0 )	break;

		USB9602R = (unsigned char)adr;
		*buff = USB9602D;
		buff++;
		rcnt++;
	}
	return(rcnt);
}

static int WriteUSBBurst(int adr,int adr2,char *buff,int cnt)
{
	int		i,scnt;
	for(scnt=0,i=0;i<cnt;i++)
	{
		if( (ReadUSB(adr2) & 0x1f) == 0 )	break;

		USB9602R = (unsigned char)adr;
		USB9602D = *buff;
		buff++;
		scnt++;
	}
	return(scnt);
}

/*==========================================================================
							TvvO								
==========================================================================*/
/* TX1M[` */
/*
	USBIɑMłȂ߁ÁA
	TX1MIɃobt@(outbuff)ɂf[^𑗐M܂B
	āAHOST͒IREADsB
	ȊÕ^C~OłEPC1FIFOobt@̃TCYɒӂB
*/
static int SendTX1()
{
	int		c,cnt,sz,i;

	cnt = 0;
	sz = read_outbuff((char*)rx2buff,64);			/* FIFO͍ő64byte */
	FlushTXC(1);									/* Mobt@tbV */
	if( sz != 0 )
	{
		cnt = WriteUSBBurst(USB_TXD1,USB_TXS1,(char*)rx2buff,sz);	/* o[Xg] */
	}
	TxTogle(1);								/* MI */
	return( cnt );							/* Mf[^Ԃ sz==cnt̂͂ */
}

/*------------------------------------------------------------*/
/*
  Mobt@
	inbuffHOST瑗Ăf[^̃obt@
	outbuffHOST֑f[^p
	̃Tvł̓Oobt@𒴂͎̂Ă܂B
	́A256oCgmۂĂ܂Bobt@ӂȂ悤
	CŏĂB
*/
#define		USBBUFFLEN	256						/* obt@̃TCY */
static	int			inpos,inlen;				/* ̓obt@ʒuATCY */
static	int			outpos,outlen;				/* o̓obt@ʒuATCY */
static	char		inbuff[USBBUFFLEN];			/* ̓Oobt@ */
static	char		outbuff[USBBUFFLEN];		/* o̓Oobt@ */

/*--------------------------------------------------------------*/
/*						obt@̏						*/
/*--------------------------------------------------------------*/
void init_usbbuff()
{
	inpos = inlen = 0;
	outpos = outlen = 0;
}

/*--------------------------------------------------------------*/
/*				HOST̎Mobt@֏				*/
/*	char	 	*p		obt@|C^						*/
/*	int			size	݃TCY							*/
/*	߂l				񂾃TCY						*/
/*--------------------------------------------------------------*/
int write_inbuff(char *p,int size)
{
	int		i;
	INTC.IER &= (-1^0x20);				/* IRQ5 Disable */
	for(i=0;i<size;i++)
	{
    	if( inlen >= USBBUFFLEN )	break;
    	inbuff[inpos] = *p;
    	inpos = (inpos + 1)%USBBUFFLEN;
    	inlen++;
        p++;
    }
	INTC.IER |= 0x20;					/* IRQ5 Enable */
	return(i);
}
/*--------------------------------------------------------------*/
/*					Mobt@֏						*/
/*	char	 	*p		obt@|C^						*/
/*	int			size	݃TCY							*/
/*	߂l				񂾃TCY						*/
/*--------------------------------------------------------------*/
int write_buff(char *p,int size)
{
	int		i;
	INTC.IER &= (-1^0x20);				/* IRQ5 Disable */
	for(i=0;i<size;i++)
	{
    	if( outlen >= USBBUFFLEN )	break;
    	outbuff[outpos%USBBUFFLEN] = *p;
    	outpos = (outpos + 1)%USBBUFFLEN;
    	outlen++;
        p++;
    }
	INTC.IER |= 0x20;					/* IRQ5 Enable */
	return(i);
}

/*--------------------------------------------------------------*/
/*					Mobt@ǂݍ					*/
/*	char		*p		obt@|C^						*/
/*	int			size	obt@őTCY						*/
/*	߂l				ǂݍ񂾃TCY						*/
/*--------------------------------------------------------------*/
int read_outbuff(char *p,int size)
{
	int	i;
	INTC.IER &= (-1^0x20);				/* IRQ5 Disable */
	for(i=0;outlen>0;i++)
	{
		if( i >= size )	break;
		p[i] = outbuff[ (USBBUFFLEN+outpos-outlen)%USBBUFFLEN ];
		outlen--;
   	}
	INTC.IER |= 0x20;					/* IRQ5 Enable */
	return(i);
}
/*--------------------------------------------------------------*/
/*					Mobt@ǂݍ					*/
/*	char		*p		obt@|C^						*/
/*	int			size	obt@őTCY						*/
/*	߂l				ǂݍ񂾃TCY						*/
/*--------------------------------------------------------------*/
int read_buff(char *p,int size)
{
	int	i;
	INTC.IER &= (-1^0x20);				/* IRQ5 Disable */
	for(i=0;inlen>0;i++)
	{
		if( i >= size )	break;
		p[i] = inbuff[ (USBBUFFLEN+inpos-inlen)%USBBUFFLEN ];
		inlen--;
   	}
	INTC.IER |= 0x20;					/* IRQ5 Enable */
	return(i);
}
/*--------------------------------------------------------------*/
/*					Mobt@̃TCY擾					*/
/*--------------------------------------------------------------*/
int get_inbufflen()
{
	return( inlen%USBBUFFLEN );
}

/*--------------------------------------------------------------*/
/*					Mobt@̃TCY擾					*/
/*--------------------------------------------------------------*/
int get_outbufflen()
{
	return( outlen%USBBUFFLEN );
}


