/*

		LCD
										(C)2002 C.I.M
*/


#include 	<stdio.h>
#include	<stdarg.h>
#include	"h83048.h"

void ClearLCD();

/* PortB (write) b0..3 = LCD(LED) out , bit4 = LCD RS , bit7 = LCD E */
#define		LCD_RS			0x10
#define		LCD_E			0x80
#define		LCDMASK			0x60

static void wait(int c)
{
	int		i,j;
	for(j=0;j<c;j++)
	{
		for(i=0;i<0x682;i++)	{}
	}
}


/*==========================================================================
							LCD BYTE o									
==========================================================================*/
/*
	̊4bitڑȂ̂ŁA4bit̂ݏo
*/
static void LCDOut8(short rs,short code)
{
	int		stat;
	int		pb;

	pb = PB.DR;					/* ݂PBDޔ */

	if( rs )	stat = (pb & LCDMASK) | LCD_RS;
	else		stat = (pb & LCDMASK);
	PB.DR = code | stat | LCD_E;
	PB.DR = code | stat;
	PB.DR = pb;					/* PBDɕA */
	wait(4);
}

/*==========================================================================
							LCD BYTE o(4bit)								
==========================================================================*/
void LCDOut4(int rs,int code)
{
	int		stat;
	int		pb;
	char	lb,hb;

	pb = PB.DR;					/* ݂PBDޔ */

	if( rs )	stat = (pb & LCDMASK) | LCD_RS;
	else		stat = (pb & LCDMASK);
	
	hb = ((code>>4)&0xf) | stat;
	lb = (code&0xf) | stat;

	PB.DR = hb | LCD_E;
	PB.DR = hb;

	PB.DR = lb | LCD_E;
	PB.DR = lb;

	PB.DR = pb;					/* PBDɕA */
	wait(4);
}

/*==========================================================================
							LCD Rg[								
----------------------------------------------------------------------------
	LCDA\ANA													
==========================================================================*/

void InitLCD()
{
	int		i;
	wait(15);
	for(i=0;i<3;i++)
	{
		LCDOut8(0,0x3);
	}
	LCDOut8(0,0x2);


	LCDOut4(0,0x28);		/* bit4=8/4bit , bit3=1/2line , bit2=large/small */
	LCDOut4(0,0x10);		/* bit3=Display/Cursor , bit2=Right/Left */
	LCDOut4(0,0x0e);		/* bit2=display , bit1=coursor , bit0=blink */
	LCDOut4(0,0x06);

	LCDOut4(0,0x01);		/* NA */
	LCDOut4(0,0x02);		/* J[\z[ */

}


/*==========================================================================
								LCD NA									
----------------------------------------------------------------------------
	LCDA\ANA													
==========================================================================*/
void ClearLCD()
{
	LCDOut4(0,0x01);	/* NA */
	LCDOut4(0,0x02);	/* J[\z[ */
}

/*==========================================================================
							LCDLN^\								
----------------------------------------------------------------------------
	'\n','\r','\f'LCDNAs܂B								
==========================================================================*/
void PutLCD(char c)
{
	if( c == '\f' )	ClearLCD();
	else if( c == '\n' )	ClearLCD();
	else if( c == '\r' )	ClearLCD();
	else LCDOut4(1,c);
}

/*==========================================================================
							LCDJ[\ړ									
----------------------------------------------------------------------------
	x = 0`15																
	y = 0,1																	
==========================================================================*/
void LocateLCD(int x,int y)
{
	LCDOut4(0,0x80 + y*0x40 + x);
}

/*==========================================================================
							LCD\									
----------------------------------------------------------------------------
	p[^printf()ƓłB64𒴂Ȃ悤ɐݒ肵ĂB
	'\f'LCDNAA'\n'͉sB											
==========================================================================*/
void PrintLCD(char *fmt,...)
{
	int		i;
	static	char	buff[64];
	va_list arg;
	va_start(arg, fmt);
	*buff = '\0';
	vsprintf(buff,fmt,arg);
	va_end(arg);
	for(i=0;;i++)
	{
		if( buff[i] == 0 )			break;
		else if( buff[i] == '\n' )	LocateLCD(0,1);		/* s 			*/
		else if( buff[i] == '\r' )	LCDOut4(0,0x2);		/* J[\z[	*/
		else if( buff[i] == '\f' )	ClearLCD();			/* LCDNA 		*/
		else						LCDOut4(1,buff[i]);	/* f[^o 		*/
	}
}

